#include <bits/stdc++.h>
using namespace std;
const long long inf=LLONG_MAX;
const long long MAXN=500009;
long long N,M,K;
vector<pair<long long,long long>> edg[MAXN];
long long cp[10];
long long dist[MAXN][10];
bool vis[MAXN];
priority_queue<pair<long long,long long>> pq;

void dijkstra(long long start,long long ind)
{
    for(long long i=1;i<=N;i++)
    {
        dist[i][ind]=inf;
        vis[i]=0;
    }
    dist[start][ind]=0;
    pq.push({0,start});

    while(!pq.empty())
    {
        long long curr=pq.top().second;
        pq.pop();

        if(vis[curr])continue;
        vis[curr]=true;

        for(auto i:edg[curr])
        {
            if(dist[i.first][ind]<=i.second+dist[curr][ind])continue;
            dist[i.first][ind]=i.second+dist[curr][ind];
            pq.push({-dist[i.first][ind],i.first});
        }
    }
}

inline long long min1(long long a,long long b)
{
    if(a>b)return b;
    return a;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long a,b,c,ans=inf;
    cin>>N>>K>>M;
    for(long long i=0;i<K;i++)cin>>cp[i];
    for(long long i=0;i<M;i++)
    {
        cin>>a>>b>>c;
        edg[a].push_back({b,c});
        edg[b].push_back({a,c});
    }
    if(K==2)
    {
        dijkstra(cp[1],0);
        cout<<dist[cp[0]][0]<<endl;
    }

    if(K==3)
    {
        dijkstra(cp[0],0);
        dijkstra(cp[1],1);
        dijkstra(cp[2],2);
        for(long long i=1;i<=N;i++)ans=min1(ans,dist[i][0]+dist[i][1]+dist[i][2]);
        cout<<ans<<endl;
    }
    dijkstra(cp[0],0);
    dijkstra(cp[1],1);
    dijkstra(cp[2],2);
    dijkstra(cp[0],3);
    for(int i=1;i<=N;i++)
    {
        dijkstra(i,4);
        for(int j=1;j<=N;j++)
        {
            ans=min1(ans,dist[i][0]+dist[i][1]+dist[j][2]+dist[j][3]+dist[j][4]);
            ans=min1(ans,dist[i][0]+dist[i][2]+dist[j][1]+dist[j][3]+dist[j][4]);
            ans=min1(ans,dist[i][0]+dist[i][3]+dist[j][2]+dist[j][1]+dist[j][4]);
        }
    }
    cout<<ans<<endl;
    return 0;
}
