#include <bits/stdc++.h>
using namespace std;
const long long inf=LLONG_MAX;
const long long MAXN=500009;
long long N,M,K;
vector<pair<long long,long long>> edg[MAXN];
vector<pair<long long,long long>> edg1[MAXN];
long long cp[10];
long long dist[MAXN][10];
bool vis[MAXN];
priority_queue<pair<long long,long long>> pq;
long long vert[MAXN][10];

void dijkstra(long long start,long long ind)
{
    for(long long i=1;i<=N;i++)
    {
        dist[i][ind]=inf;
        vis[i]=0;
    }
    dist[start][ind]=0;
    pq.push({0,start});

    while(!pq.empty())
    {
        long long curr=pq.top().second;
        pq.pop();

        if(vis[curr])continue;
        vis[curr]=true;

        for(auto i:edg[curr])
        {
            if(dist[i.first][ind]<=i.second+dist[curr][ind])continue;
            dist[i.first][ind]=i.second+dist[curr][ind];
            pq.push({-dist[i.first][ind],i.first});
        }
    }
}

inline long long min1(long long a,long long b)
{
    if(a>b)return b;
    return a;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long a,b,c,ans=inf;
    cin>>N>>K>>M;
    for(long long i=0;i<K;i++)cin>>cp[i];
    for(long long i=0;i<M;i++)
    {
        cin>>a>>b>>c;
        edg[a].push_back({b,c});
        edg[b].push_back({a,c});
    }
    dijkstra(cp[0],0);
    dijkstra(cp[1],1);
    dijkstra(cp[2],2);
    dijkstra(cp[3],3);
    for(long long i=1;i<=N;i++)
    {
        vert[i][0]=dist[i][0]+dist[i][1];
        vert[i][5]=dist[i][3]+dist[i][2];
        vert[i][1]=dist[i][0]+dist[i][2];
        vert[i][4]=dist[i][1]+dist[i][3];
        vert[i][2]=dist[i][0]+dist[i][3];
        vert[i][3]=dist[i][3]+dist[i][2];
    }
    for(int i=1;i<=N;i++)edg1[i]=edg[i];
    for(int i=1;i<=N;i++)edg[N+1].push_back({i,vert[i][0]});
    for(int i=1;i<=N;i++)edg[i].push_back({N+2,vert[i][5]});
    dijkstra(N+1,6);
    ans=min1(ans,dist[N+2][6]);

    for(int i=1;i<=N;i++)edg[i]=edg1[i];
    for(int i=1;i<=N;i++)edg[N+1].push_back({i,vert[i][1]});
    for(int i=1;i<=N;i++)edg[i].push_back({N+2,vert[i][4]});
    dijkstra(N+1,6);
    ans=min1(ans,dist[N+2][6]);

    for(int i=1;i<=N;i++)edg[i]=edg1[i];
    for(int i=1;i<=N;i++)edg[N+1].push_back({i,vert[i][2]});
    for(int i=1;i<=N;i++)edg[i].push_back({N+2,vert[i][3]});
    dijkstra(N+1,6);
    ans=min1(ans,dist[N+2][6]);
    cout<<ans<<endl;
    return 0;
}
