#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX=(1e5)+5;

int a[MAX],b[MAX],n;

int Next(int y,int z)
{
    int l=y,r=n+1,m;
    while(r-l>1)
    {
        m=l+(r-l)/2;
        if(a[m]-a[y]>=z)
            r=m;
        else
            l=m;
    }
    if(a[r]-a[y]==z)
        return r;
    else
        return -1;
}

bool Check(int x,int y)
{
    if(x!=-1&&y<=n)
    {
        for(int i=1; i<=n; i++)
            b[i]=0;
        int z=a[y]-a[x];
        b[x]=b[y]=1;
        while(Next(y,z)!=-1)
        {
            y=Next(y,z);
            b[y]=1;
        }
    }
    int l=-1,prev=-1;
    for(int i=1; i<=n; i++)
    {
        if(b[i]==1)
            continue;
        if(prev==-1)
            prev=a[i];
        else
        {
            if(l==-1)
                l=a[i]-prev;
            else if(a[i]-prev!=l)
                return 0;
            prev=a[i];
        }
    }
    return 1;
}

void Print()
{
    int cnt=0;
    for(int i=1; i<=n; i++)
    {
        cnt+=b[i];
    }
    cout<<cnt<<" "<<n-cnt<<endl;
    for(int i=1; i<=n; i++)
    {
        if(b[i])
            cout<<a[i]<<" ";
    }
    cout<<endl;
    for(int i=1; i<=n; i++)
    {
        if(!b[i])
            cout<<a[i]<<" ";
    }
    cout<<endl;
}

void Solve()
{
    cin>>n;
    for(int i=1; i<=n; i++)
    {
        cin>>a[i];
    }
    sort(a+1,a+n+1);
    for(int i=1; i<=n; i++)
    {
        for(int j=i+1; j<=n; j++)
        {
            if(Check(i,j))
            {
                Print();
                return;
            }
        }
    }
    srand(time(0));
    for(int i=1;i<=n-2;i++)
    {
        if(Check(rand()%n+1,rand()%n+2))
        {
            Print();
            return;
        }
        if(Check(rand()%n+1,rand()%n+3))
        {
            Print();
            return;
        }
    }
    cout<<-1<<endl;
}

signed main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    Solve();
    return 0;
}
