#include<iostream>
#include "saddle.h"
using namespace std;
pair <int, int> find_saddle_point (int N, int M)
{
    long long table[N+2][M+2];
    for(long long i=0;i<N+2;i++)
    {
        for(long long j=0;j<M+2;j++)
        {
            table[i][j]=0;
        }
    }
    for(long long i=1;i<=N;i++)
    {
        for(long long j=1;j<=M;j++)
        {
            table[i][j]=value(i,j);
        }
    }
    for(long long i=1;i<=N;i++)
    {
        for(long long j=1;j<=M;j++)
        {
            if(table[i-1][j]>table[i][j] && table[i][j-1]>table[i][j] && table[i+1][j]>table[i][j] && table[i][j+1]>table[i][j])
            {
                return {i,j};
            }
        }
    }
}
