#include<bits/stdc++.h>
#include "saddle.h"

using namespace std;


long long a[505][505];

bool isIn (int x, int y, int n, int m) {
    return x >= 1 && y >= 1 && x <= n && y <= m;
}
pair <int, int> find_saddle_point (int n, int m) {
    int dx[] = {1, -1, 0, 0};
    int dy[] = {0, 0, 1, -1};

    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= m; j ++) {
            a[i][j] = value(i, j);
            if (i > 1) {
                bool works = true;
                for (int dir = 0; dir < 4; dir ++) {
                    if (isIn(i + dx[dir] - 1, j + dy[dir], n, m) && a[i - 1 + dx[dir]][j + dy[dir]] < a[i - 1][j]) works = false;
                }

                if (works) return {i - 1, j};

            }
        }
    }

    int i = n;
    for (int j = 1; j <= m; j ++) {
        bool works = true;
        for (int dir = 0; dir < 4; dir ++) {
            if (isIn(i + dx[dir], j + dy[dir], n, m) && a[i + dx[dir]][j + dy[dir]] < a[i][j]) works = false;
        }

        if (works) return {i, j};
    }
    return {5, 5};
}

