#include<bits/stdc++.h>
#include "saddle.h"

using namespace std;


long long int  a[505];

bool isIn(int x, int m) {
    return x >= 1 && x <= m;
}


bool test (int mid) {
    if (isIn(mid - 1) && a[mid - 1] < a[mid]) return false;
    if (isIn(mid + 1) && a[mid + 1] < a[mid]) return false;

    return true;
}
pair <int, int> find_saddle_point (int n, int m) {
    srand(time(0));

    for (int i = 1; i <= m; i ++) {
        a[i] = -1;
    }
    a[1] = value(1, 1);
    if (m > 1) a[2] = value(1, 2);
    if (m > 1 && a[1] < a[2]) return {1, 1};

    if (a[m] == -1) a[m] = value(1, m);
    if (a[m - 1] == -1) a[m - 1] = value(1, m - 1);
    if (m > 1 && a[m] < a[m - 1]) return {1, m};

    while (true) {
        int mid = ( rand() % m ) + 1;

        if (a[mid] == -1) {
            a[mid] = value(1, mid);
        }
        if (mid > 1) {
            if (a[mid - 1] == -1) a[mid - 1] = value(1, mid - 1);
        }
        if (mid < m) {
            if (a[mid + 1] == -1) a[mid + 1] = value(1, mid + 1);
        }

        if (test(mid)) return {1, mid};

        if (isIn(mid - 2) && a[mid - 2] != -1) {
            if (test(mid - 1)) return {1, mid - 1};
        }
        if (isIn(mid + 2) && a[mid + 2] != -1) {
            if (test(mid + 1)) return {1, mid + 1};
        }
    }
    return {1, 1};
}
