# include <iostream>
# include <algorithm>
# include <vector>
using namespace std;

const int MAX=1e5+11;
int a[MAX];
bool used[MAX];
int n;

void reset()
{
    for(int i=1;i<=n;i++) used[i]=0;
}

bool check()
{
    int last1=-1, last2=-1;
    for(int i=1;i<=n;i++)
    {
        if(used[i]==1) continue;

        if(last1==-1) {last1=i;}
        else if(last2==-1) {last2=last1;last1=i;}
        else if(a[i]-a[last1]!=a[last1]-a[last2]) return false;
        else {last2=last1;last1=i;}
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++) cin>>a[i];
    sort(a+1,a+n+1);

    for(int i=1; i<=n; i++)
    {
        for(int j=i+1; j<=n; j++)
        {
            reset();

            int d=a[j]-a[i];
            int last=j;
            used[i]=1;
            used[j]=1;

            for(int k=j+1; k<=n; k++)
            {
                if(a[k]-a[last]==d)
                {
                    used[k]=1;
                    last=k;
                }
            }

            if(check())
            {
                vector<int> v1,v2;
                for(int k=1; k<=n; k++)
                {
                    if(used[k]==1) v1.push_back(a[k]);
                    else v2.push_back(a[k]);
                }

                if((int)v2.size()==0)
                {
                    v2.push_back(v1.back());
                    v1.pop_back();
                }
                cout<<v1.size()<<" "<<v2.size()<<" "<<"\n";
                for(int x: v1) cout<<x<<" ";
                cout<<"\n";
                for(int x: v2) cout<<x<<" ";
                cout<<"\n";

                return 0;
            }

            used[last]=0;
            if(check())
            {
                vector<int> v1,v2;
                for(int k=1; k<=n; k++)
                {
                    if(used[k]==1) v1.push_back(a[k]);
                    else v2.push_back(a[k]);
                }

                if((int)v2.size()==0)
                {
                    v2.push_back(v1.back());
                    v1.pop_back();
                }
                cout<<v1.size()<<" "<<v2.size()<<" "<<"\n";
                for(int x: v1) cout<<x<<" ";
                cout<<"\n";
                for(int x: v2) cout<<x<<" ";
                cout<<"\n";

                return 0;

            }

            //cout<<1<<" "<<j<<"\n";
        }
    }


    cout<<-1<<"\n";

    return 0;
}
