# include <iostream>
# include "saddle.h"
//# include "Lgrader.cpp"
using namespace std;

const long long INF=1e18+111;
const int MAX=512;
long long a[MAX][MAX];
bool vis[MAX][MAX];
int adj[4][2]={{1,0},{0,1},{-1,0},{0,-1}};
pair<int, int> ans={-1,-1};
int N,M;

bool in(int x, int y)
{
    return (1<=x and x<=N and 1<=y and y<=M);
}

long long get_val(int x, int y)
{
    if(x==0 and y==0) return INF;

    if(a[x][y]!=0) return a[x][y];
    a[x][y]=value(x,y);
    return a[x][y];
}

int BP=150;
int TM=0;

void dfs(int x, int y)
{
    TM++;
    if(TM==BP+1) return ;

    vis[x][y]=1;
    long long d=get_val(x,y);
    pair<int, int> nxt={0,0};

    for(int k=0;k<4;k++)
    {
        int x2=x+adj[k][0];
        int y2=y+adj[k][1];

        if(in(x2,y2) and get_val(x2,y2)<get_val(nxt.first,nxt.second) and !vis[x2][y2])
        {
            nxt={x2,y2};
        }
    }

    if(d<get_val(nxt.first,nxt.second)) {ans={x,y};return ;}
    dfs(nxt.first,nxt.second);
}

pair <int, int> find_saddle_point (int _N, int _M)
{
    N=_N;
    M=_M;

    dfs(1,1);
    if(ans.first!=-1) return ans;
    BP=300;
    dfs(N,M);
    return ans;
}
