#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 1;
int N;
int A[MAXN];
int Visited[MAXN];
int Marker;
unordered_map<int, int> Position;
bool Over = false;
int II;
int Previous = 0;
int DIFF;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;

    for(int i = 0; i < N; i++)
    {
        cin >> A[i];
        Position[A[i]] = i + 1;
    }

    sort(A, A + N);

    for(int i = 0; i < N; i++)
    {
        Position[A[i]] = i + 1;
    }
}

bool Check()
{
    for(II; II < N; II++)
    {
        if(Visited[II] == Marker)
        {
            continue;
        }

        if(Previous != 0)
        {
            if(DIFF == -1)
            {
                DIFF = A[II] - Previous;
            }
            else
            {
                if(A[II] - Previous != DIFF)
                {
                    return false;
                }
            }
        }

        Previous = A[II];
    }

    return true;
}

void Calc(int Index, int Diff)
{
    Marker++;
    Visited[0] = Marker;
    Visited[Index] = Marker;

    if(Check())
    {
        Over = true;
        vector<int> X, Y;

        for(int i = 0; i < N; i++)
        {
            if(Visited[i] == Marker)
            {
                X.push_back(A[i]);
            }
            else
            {
                Y.push_back(A[i]);
            }
        }

        cout << X.size() << " " << Y.size() << '\n';

        for(auto& u : X)
        {
            cout << u << " ";
        }

        cout << '\n';

        for(auto& u : Y)
        {
            cout << u << " ";
        }

        return;
    }

    while(A[Index] + Diff <= 1e9)
    {
        Index = Position[A[Index] + Diff];

        if(Index == 0)
        {
            break;
        }

        Index--;

        Visited[Index] = Marker;

        if(Check())
        {
            Over = true;
            vector<int> X, Y;

            for(int i = 0; i < N; i++)
            {
                if(Visited[i] == Marker)
                {
                    X.push_back(A[i]);
                }
                else
                {
                    Y.push_back(A[i]);
                }
            }

            cout << X.size() << " " << Y.size() << '\n';

            for(auto& u : X)
            {
                cout << u << " ";
            }

            cout << '\n';

            for(auto& u : Y)
            {
                cout << u << " ";
            }

            return;
        }
    }
}

void Difference()
{
    bool Good = true;

    for(int i = 3; i < N; i++)
    {
        if(A[i] - A[i - 1] != A[2] - A[1])
        {
            Good = false;
            break;
        }
    }

    if(Good)
    {
        cout << 1 << " " << N - 1 << '\n';
        cout << A[0] << '\n';

        for(int i = 1; i < N; i++)
        {
            cout << A[i] << " ";
        }

        return;
    }

    for(int i = 1; i < N; i++)
    {
        int Diff = A[i] - A[0];
        II = 0;
        Previous = 0;
        DIFF = -1;
        Calc(i, Diff);

        if(Over)
        {
            return;
        }
    }

    cout << -1;
}

void Solve()
{
    Difference();
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
