#include <bits/stdc++.h>
#include "saddle.h"
using namespace std;
/*
pair<long long, long long> Dfs(long long X, long long Y, long long N, long long M, long long Starter)
{
    queue<tuple<long long, long long, long long>> Q;
    Q.push({X, Y, Starter});
    Visited[X][Y] = true;

    while(!Q.empty())
    {
        tuple<long long, long long, long long> Top = Q.front();
        Q.pop();
        long long Ox = get<0>(Top);
        long long Oy = get<1>(Top);
        long long Current = get<2>(Top);
        bool IsLocal = true;
        ////cout << Ox << " " << Oy << '\n';

        for(int i = 0; i < 4; i++)
        {
            int Nx = Ox + DirsX[i];
            int Ny = Oy + DirsY[i];

            if(Nx < 1 || Nx > N || Ny < 1 || Ny > M)
            {
                continue;
            }

            if(Visited[Nx][Ny])
            {
                continue;
            }

            Visited[Nx][Ny] = true;
            long long Value = value(Nx, Ny);

            if(Value < Current)
            {
                IsLocal = false;
                Q.push({Nx, Ny, Value});
                break;
            }
        }

        if(IsLocal)
        {
            return {Ox, Oy};
        }
    }
}
*/

pair<int, int> find_saddle_point(int N, int M)
{
    int l = 1, r = M;
    int mid;
    int Answer = 0;
    int Comp = value(1, 1);

    while(l <= r)
    {
        mid = (l + r) / 2;

        if(value(1, mid) > Comp)
        {
            r = mid - 1;
        }
        else
        {
            Answer = mid;
            l = mid + 1;
        }
    }

    return {1, Answer};
}
