#include <bits/stdc++.h>
using namespace std;

multiset <int> nums, nums_copy;

unordered_map <int, int> BR;

void output(multiset <int> s) {
    for (auto x : s) cout << x << ' ';
    cout << endl;
}

void ERASE(multiset <int>& s, int x) {
    nums.erase(x);
    BR[x]--;

    for (int i = 0; i < BR[x]; i++) {
        nums.insert(x);
    }
}

pair <multiset <int>, multiset <int>> check(int a, int r) {
    int current = a;

    multiset <int> one, two;

    while (nums.find(current) != nums.end()) {
        ERASE(nums, current);
        one.insert(current);
        current += r;
    }

    if (nums.size() < 2) return {one, nums};

    auto it = nums.begin();
    current = *it;

    r = -(*(it));
    it++;
    r += *it;

    while (nums.find(current) != nums.end()) {
        ERASE(nums, current);
        two.insert(current);
        current += r;
    }

    if (nums.size()) return {};
    return {one, two};
}


void output(pair <multiset <int>, multiset <int>>& p) {
    cout << p.first.size() << ' ' << p.second.size() << '\n';
    for (int x : p.first) cout << x << ' ';
    cout << endl;
    for (int x : p.second) cout << x << ' ';
    cout << endl;
}

bool valid(pair <multiset <int>, multiset <int>>& p) {
    return ((bool) p.first.size()) || ((bool) p.second.size());
}

int v[100001];

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> v[i];

        nums_copy.insert(v[i]);
        BR[v[i]]++;

        if (BR[v[i]] > 2) {
            cout << -1 << endl;
            return 0;
        }
    }

    sort(v, v + n);

    pair <multiset <int>, multiset <int>> ans;

    nums = nums_copy;
    ans = check(v[0], v[1] - v[0]);

    if (valid(ans)) {
        output(ans);
        return 0;
    }

    if (n == 2) {
        cout << -1 << endl;
        return 0;
    }

    nums = nums_copy;
    ans = check(v[0], v[2] - v[0]);

    if (valid(ans)) {
        output(ans);
        return 0;
    }

    nums = nums_copy;
    ans = check(v[1], v[2] - v[1]);

    if (valid(ans)) {
        output(ans);
        return 0;
    }

    cout << -1 << endl;

    return 0;

}
