#include <bits/stdc++.h>
using namespace std;

long long a[100001];

void output(vector <long long>& one, vector <long long>& two) {
    cout << one.size() << ' ' << two.size() << '\n';
    for (long long x : one) cout << x << ' ';
    cout << endl;
    for (long long x : two) cout << x << ' ';
    cout << endl;
}

long long n;

void check(long long v, long long r) {
    vector <long long> one, two;

    long long diff = -1, last_1 = v - r, last_2 = -1;

    for (long long i = 1; i <= n; i++) {
        //cout << i << endl;
        if (a[i] - last_1 == r) {
            one.push_back(a[i]);
            last_1 = a[i];
        } else if (last_2 == -1) {
            last_2 = a[i];
            two.push_back(a[i]);
        } else if (diff == -1) {
            diff = a[i] - last_2;
            //cout << "DIFF SET TO " << diff << endl;
            last_2 = a[i];
            two.push_back(a[i]);
        } else if (diff == a[i] - last_2) {
            last_2 = a[i];
            two.push_back(a[i]);
        } else return;

        //cout << r << ' ' << last_1 << ' ' << diff << ' ' << last_2 << endl;
    }

    //cout << "YES" << endl;

    if (one.empty()) {
        one.push_back(two.back());
        two.pop_back();
    } else if (two.empty()) {
        two.push_back(one.back());
        one.pop_back();
    }

    output(one, two);
    exit(0);
}

long long main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (long long i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);

    check(a[1], a[2] - a[1]);

    if (n <= 2) {
        cout << -1 << endl;
        return 0;
    }

    check(a[1], a[3] - a[1]);
    check(a[2], a[3] - a[2]);

    cout << -1 << endl;
    return 0;

}
