#include <bits/stdc++.h>
#include "saddle.h"
using namespace std;

int v[501][501];
int N, M;

bool is_valid_cell(int x, int y) {
    return 0 < x && x <= N && 0 < y && y <= M;
}

pair <long long, pair <int, int>> ask(int x, int y) {
    if (!is_valid_cell(x, y)) return {INT_MAX, {x, y}};
    if (v[x][y] != 0) return {v[x][y], {x, y}};
    v[x][y] = value(x, y);

    return {v[x][y], {x, y}};
}

pair <long long, pair <int, int>> ask_group(int x, int y) {
    auto ans = min({ask(x - 1, y), ask(x + 1, y), ask(x, y - 1), ask(x, y + 1)});
    if (ans.first > ask(x, y).first) return {-1, {0, 0}};
    return ans;
}

pair <int, int> find_saddle_point(int n, int m) {
    N = n;
    M = m;

    int x = (N + 1) / 2, y = (M + 1) / 2, br = 0;

    while (br < n * m + 2) {
        auto val = ask_group(x, y);
        if (val.first == -1) return {x, y};
        x = val.second.first;
        y = val.second.second;

        br++;
    }

    return {x, y};
}
