#include<iostream>
#include "saddle.h"
using namespace std;

typedef long long ll;

ll a[512][512];
int n1, m1;

pair < int, int > dir[4] = {
{0, 1},
{1, 0},
{0, -1},
{-1, 0}
};

bool inside(pair < int, int > c)
{
    return 1 <= c.first && c.first <= n1 && 1 <= c.second && c.second <= m1;
}

pair <int, int> find_saddle_point (int N, int M)
{
    n1 = N;
    m1 = M;
    for(int i = 1; i <= n1; i++)
    {
        for(int j = 1; j <= m1; j++)
        {
            a[i][j] = value(i, j);
        }
    }

    for(int i = 1; i <= n1; i++)
    {
        for(int j = 1; j <= m1; j++)
        {
            pair < int, int > cur = {i, j};
            bool lampa = true;
            for(int k = 0; k < 4; k++)
            {
                pair < int, int > nb = {cur.first + dir[k].first, cur.second + dir[k].second};

                if(!inside(nb))
                    continue;

                if(a[nb.first][nb.second] < a[cur.first][cur.second])
                {
                    lampa = false;
                    break;
                }
            }

            if(lampa)
                return cur;
        }
    }
}
