#include<bits/stdc++.h>
#include "saddle.h"
using namespace std;

typedef long long ll;

ll a[512][512];
int n1, m1;

pair < int, int > dir[4] = {
{0, 1},
{1, 0},
{0, -1},
{-1, 0}
};

bool inside(pair < int, int > c)
{
    return 1 <= c.first && c.first <= n1 && 1 <= c.second && c.second <= m1;
}

ll get_value(pair < int, int > c)
{
    if(a[c.first][c.second])
        return a[c.first][c.second];

    return a[c.first][c.second] = value(c.first, c.second);
}

bool check(pair < int, int > pot)
{
    ll val = get_value(pot);

    for(int i = 0; i < 4; i++)
    {
        pair < int, int > nb = {dir[i].first + pot.first, dir[i].second + pot.second};

        if(!inside(nb))
            continue;

        if(get_value(nb) < val)
            return false;
    }

    return true;
}

pair <int, int> find_saddle_point (int N, int M)
{
    srand(time(0));
    n1 = N;
    m1 = M;

    while(true)
    {
        int x = rand() % n1 + 1;
        int y = rand() % m1 + 1;

        if(check({x, y}))
            return {x, y};
    }
}
