#include<iostream>
#include"saddle.h"
#include"Lgrader.cpp"
#define ll long long
using namespace std;
int val[1000];

pair <int, int> find_saddle_point (int N, int M) {
    int l = 0, r = M + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (m == M) {
            return { 1, m };
        }
        if (val[m] == 0) {
            val[m] = value(1, m);
        }
        if (val[m + 1] == 0) {
            val[m + 1] = value(1, m + 1);
        }
        if (val[m] < val[m + 1]) {
            r = m;
        } else {
            l = m;
        }
    }
    int curY = 0;
    int curX = r;
    ll curVal = val[r];
    int lastDir = -1;
    while (1) {
        if (lastDir != 1 && curX + 1 <= N) {
            ll newVal = value(curY, curX + 1);
            if (newVal < curVal) {
                curVal = newVal;
                curX++;
                lastDir = 1;
                continue;
            }
        }
        if (lastDir != 2 && curY + 1 <= M) {
            ll newVal = value(curY + 1, curX);
            if (newVal < curVal) {
                curVal = newVal;
                curY++;
                lastDir = 2;
                continue;
            }
        }
        if (lastDir != 3 && curX > 1) {
            ll newVal = value(curY, curX - 1);
            if (newVal < curVal) {
                curVal = newVal;
                curX--;
                lastDir = 3;
                continue;
            }
        }
        if (lastDir != 4 && curY > 1) {
            ll newVal = value(curY - 1, curX);
            if (newVal < curVal) {
                curVal = newVal;
                curY--;
                lastDir = 4;
                continue;
            }
        }
        return {curY, curX};
    }
}
