#include <bits/stdc++.h>
using namespace std;
const long long inf=10000000000LL;
long long dist[25][25];
long long N,M,K;
long long cp[10];

void floyd()
{
    for(int i=1;i<=N;i++)
        for(int j=1;j<=N;j++)
            for(int k=1;k<=N;k++)
    {
        if(dist[i][j]>dist[i][k]+dist[k][j])dist[i][j]=dist[i][k]+dist[k][j];
    }
}

inline long long min1(long long a,long long b)
{
    if(a>b)return b;
    return a;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long a,b,c,ans=inf;
    cin>>N>>K>>M;
    for(int i=1;i<=N;i++)for(int j=1;j<=N;j++)dist[i][j]=inf;
    for(long long i=0;i<K;i++)cin>>cp[i];
    for(long long i=0;i<M;i++)
    {
        cin>>a>>b>>c;
        dist[a][b]=dist[b][a]=c;
        dist[a][a]=dist[b][b]=0;
    }
    floyd();
    if(K==2)
    {
        cout<<dist[cp[0]][cp[1]]<<endl;
    }

    if(K==3)
    {
        for(long long i=1;i<=N;i++)ans=min1(ans,dist[cp[0]][i]+dist[cp[1]][i]+dist[cp[2]][i]);
        cout<<ans<<endl;
    }

    if(K==4)
    {
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[0]][i]+dist[cp[1]][i]+ dist[i][j] +dist[cp[2]][j]+dist[cp[3]][j]);
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[0]][i]+dist[cp[2]][i]+ dist[i][j] +dist[cp[1]][j]+dist[cp[3]][j]);
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[0]][i]+dist[cp[3]][i]+ dist[i][j] +dist[cp[2]][j]+dist[cp[1]][j]);
        cout<<ans<<endl;
    }

    if(K==5)
    {
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[0]][i]+dist[cp[1]][i]+ dist[i][j] +dist[cp[2]][j]+dist[cp[3]][j]+dist[cp[4]][j]);
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[0]][i]+dist[cp[2]][i]+ dist[i][j] +dist[cp[1]][j]+dist[cp[3]][j]+dist[cp[4]][j]);
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[0]][i]+dist[cp[3]][i]+ dist[i][j] +dist[cp[1]][j]+dist[cp[2]][j]+dist[cp[4]][j]);
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[0]][i]+dist[cp[4]][i]+ dist[i][j] +dist[cp[1]][j]+dist[cp[2]][j]+dist[cp[3]][j]);

        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[1]][i]+dist[cp[2]][i]+ dist[i][j] +dist[cp[0]][j]+dist[cp[3]][j]+dist[cp[4]][j]);
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[1]][i]+dist[cp[3]][i]+ dist[i][j] +dist[cp[0]][j]+dist[cp[2]][j]+dist[cp[4]][j]);
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[1]][i]+dist[cp[4]][i]+ dist[i][j] +dist[cp[0]][j]+dist[cp[2]][j]+dist[cp[3]][j]);

        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[2]][i]+dist[cp[3]][i]+ dist[i][j] +dist[cp[0]][j]+dist[cp[1]][j]+dist[cp[4]][j]);
        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[2]][i]+dist[cp[4]][i]+ dist[i][j] +dist[cp[1]][j]+dist[cp[0]][j]+dist[cp[3]][j]);

        for(long long i=1;i<=N;i++)
            for(long long j=1;j<=N;j++)ans=min1(ans,
                                                dist[cp[3]][i]+dist[cp[4]][i]+ dist[i][j] +dist[cp[1]][j]+dist[cp[0]][j]+dist[cp[2]][j]);

        vector<int> v={0,1,2,3,4};
        do
        {
            ans=min1(ans,dist[cp[v[0]]][cp[v[1]]]+dist[cp[v[2]]][cp[v[1]]]+dist[cp[v[2]]][cp[v[3]]]+dist[cp[v[3]]][cp[v[4]]]);
        }while(next_permutation(v.begin(),v.end()));
        cout<<ans<<endl;
    }

    return 0;
}
