#include<bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << " "

#ifndef LOCAL
    #define cerr if(false)cerr
#endif

const int MAX_N = 1e5 + 10;
const int INF = 1e9 + 10;
const int MOD = 1e9 + 7;

bool checked[MAX_N];
int dist[MAX_N][10];
int n, k, m;
vector <int> imp;
vector <pair <int, int>> v[MAX_N];
void dijkstra (int start, int distInd) {
    for (int i = 0; i < n; i ++) {
        checked[i] = false;
        dist[i][distInd] = INF;
    }

    priority_queue<pair<int, pair<int, pair<int, int>>>> pq;
    pq.push({0, {start, {-1, -1}}});
    dist[start][distInd] = 0;
    while (!pq.empty()) {
        auto current = pq.top();
        pq.pop();

        int here = current.second.first;
        if (checked[here]) continue;

        int from = current.second.second.first;


        for (int i = 0; i < v[here].size(); i ++) {
            int sused = v[here][i].first;
            int duljina = v[here][i].second;

            if (dist[sused][distInd] > dist[here][distInd] + duljina) {
                dist[sused][distInd] = dist[here][distInd] + duljina;
                pq.push({-dist[sused][distInd], {sused, {here, duljina}}});
            }
        }
    }
}

int main () {
    #ifndef LOCAL
        ios_base::sync_with_stdio(false);
        cin.tie(NULL);
        cout.tie(NULL);
    #endif

    cin >> n >> k >> m;

    for (int i = 0; i < k; i ++) {
        int a;
        cin >> a; a--;
        imp.push_back(a);
    }

    for (int i = 0; i < m; i ++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        v[a].push_back({b, c});
        v[b].push_back({a, c});
    }

    for (int i = 0; i < k; i ++) {
        dijkstra(imp[i], i);
    }
    int ans = INF;
    for (int i = 0; i < n; i ++) {
        int sum = 0;
        for (int j = 0; j < k; j ++) {
            sum += dist[i][j];
        }
        ans = min(ans, sum);
    }
    cout << ans << endl;
    return 0;
}
/*
7 4 9
2 3 4 7
7 6 4
6 4 4
5 4 8
5 2 1
5 1 5
3 5 7
3 7 3
1 3 2
1 7 1

*/
