# include <iostream>
# include <vector>
using namespace std;

struct edge
{
    int u,v;
    long long w;

    void constr(int _u, int _v, long long _w)
    {
        u=_u;
        v=_v;
        w=_w;
    }
};

const long long INF=1e18;
const int MAXM=(1<<20)+11;
const int MAX=64;
long long dp[MAXM];
int spec[MAX];
edge a[MAX];
int n,k,m;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>k>>m;
    for(int i=0;i<k;i++) cin>>spec[i];
    for(int i=1;i<=m;i++)
    {
        int u,v;
        long long w;
        cin>>u>>v>>w;

        u--;
        v--;
        a[i]={u,v,w};
    }

    for(int mask=1;mask<(1<<n);mask++)
    {
        dp[mask]=INF;
    }
    for(int i=0;i<n;i++) dp[(1<<i)]=0;

    for(int mask=1;mask<(1<<n);mask++)
    {
        //cout<<mask<<":"<<dp[mask]<<"\n";
        for(int i=1;i<=m;i++)
        {
            edge e=a[i];
            //cout<<e.u<<" "<<e.v<<" "<<e.w<<"\n";
            if(((1<<e.u)&mask)>0)
            {
                int mask2=(mask|(1<<e.v));
                dp[mask2]=min(dp[mask2],dp[mask]+e.w);
            }

            if(((1<<e.v)&mask)>0)
            {
                int mask2=(mask|(1<<e.u));
                dp[mask2]=min(dp[mask2],dp[mask]+e.w);
            }
        }
    }

    long long ans=INF;
    int spec_mask=0;
    for(int i=0;i<k;i++)
    {
        spec[i]--;
        spec_mask=(spec_mask|(1<<spec[i]));
    }

    //cout<<spec_mask<<"\n";
    for(int i=1;i<(1<<n);i++) if((i&spec_mask)==spec_mask) ans=min(ans,dp[i]);

    cout<<ans<<"\n";

    return 0;
}
