# include <iostream>
# include "saddle.h"
//# include "Lgrader.cpp"
using namespace std;

const long long INF=1e18+111;
const int INF2=1e9;
const int MAX=512;
long long a[MAX][MAX];
int N,M;

bool in(int x, int y)
{
    return (1<=x and x<=N and 1<=y and y<=M);
}

long long get_val(int x, int y)
{
    if(!in(x,y)) return INF;

    if(a[x][y]!=0) return a[x][y];
    a[x][y]=value(x,y);
    return a[x][y];
}

pair<int, int> dq(int l, int r)
{
    //cout<<l<<" "<<r<<endl;

    if(l>r) return {INF2,INF2};

    int mid=(l+r)/2;
    long long val=get_val(1,mid);
    long long le=get_val(1,mid-1);
    long long ri=get_val(1,mid+1);
    if(le>val and val<ri) return {1,mid};

    if(l==r) return {INF2,INF2};

    if(le>ri) return dq(l,mid);
    else return dq(mid+1,r);

    /*
    pair<int, int> ans=dq(l,mid);
    if(ans.first!=INF2) return ans;
    return dq(mid+1,r);
    */
}

pair <int, int> find_saddle_point (int _N, int _M)
{
    N=_N;
    M=_M;

    return dq(1,M);
}

