#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 1;
long long N, K, M;
vector<pair<long long, long long>> Graph[MAXN];
bool Special[MAXN];
bool Visited[MAXN];
long long Start;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K >> M;

    for(long long i = 0; i < K; i++)
    {
        long long U; cin >> U;
        Special[U] = true;
        Start = U;
    }

    for(int i = 0; i < M; i++)
    {
        long long U, V, W; cin >> U >> V >> W;
        Graph[U].push_back({V, W});
        Graph[V].push_back({U, W});
    }
}

long long Answer = 1e18;

void Dfs(long long U, long long W, long long Counter)
{
    if(Visited[U])
    {
        return;
    }

    Visited[U] = true;

    if(Special[U])
    {
        Counter++;
    }

    if(Counter == K)
    {
        Answer = min(Answer, W);
        return;
    }

    for(auto& V : Graph[U])
    {
        Dfs(V.first, W + V.second, Counter);
    }

    if(Special[U])
    {
        Counter--;
    }

    Visited[U] = false;
}

void Solve()
{
    Dfs(Start, 0, 0);
    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

