#include <bits/stdc++.h>
using namespace std;

int n, a[100001];
vector <int> b[100001];
bitset <100001> occupied;

pair <vector <int>, vector <int>> check(int x, int y) {
    int r = a[y] - a[x], idx = x;
    //cout << "R IS " << r << endl;

    while (idx <= n) {
        if (idx == 0) {
            //cout << a[idx] << " IS OCCUPIED" << endl;
            break;
        }
        occupied[idx] = 1;
        //cout << "OCCUPIED " << a[idx] << endl;

        //cout << "IDX FROM " << idx << " TO ";
        //cout << idx << " TO ";
        if (a[idx] + r > a[n]) break;
        int pot = upper_bound(b[a[idx] + r].begin(), b[a[idx] + r].end(), idx) - b[a[idx] + r].begin();
        if (pot == b[a[idx] + r].size()) break;

        idx = b[a[idx] + r][pot];
        //cout << idx << endl;
        //cout << idx << endl;
    }

    int diff = -1, last = 0;

    vector <int> one, two;

    for (int i = 1; i <= n; i++) {
        //cout << "2";
        if (occupied[i]) {
            one.push_back(a[i]);
            occupied[i] = 0;
            continue;

        }

        two.push_back(a[i]);

        if (last == 0) {
            last = a[i];
        } else if (diff == -1) {
            diff = a[i] - last;
            last = a[i];
        } else {
            if (diff != a[i] - last) {
                //cout << last << ' ' << a[i] << ' ' << diff << endl;
                for (int j = i; j <= n; j++) occupied[j] = 0;
                return {vector <int> (), vector <int> ()};
            }
            last = a[i];
        }
    }

    for (int i = 1; i <= n; i++) occupied[i] = 0;
    return {one, two};
}

void output(pair <vector <int>, vector <int>>& p) {
    cout << p.first.size() << ' ' << p.second.size() << '\n';
    for (int x : p.first) cout << x << ' ';
    cout << endl;
    for (int x : p.second) cout << x << ' ';
    cout << endl;
}

bool valid(pair <vector <int>, vector <int>>& p) {
    return ((bool) p.first.size()) || ((bool) p.second.size());
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);

    for (int i = 1; i <= n; i++) {
        b[a[i]].push_back(i);
    }

    pair <vector <int>, vector <int>> ans;

    ans = check(1, 2);

    if (valid(ans)) {
        output(ans);
        return 0;
    }

    if (n == 2) {
        cout << -1 << endl;
        return 0;
    }


    ans = check(1, 3);

    if (valid(ans)) {
        output(ans);
        return 0;
    }


    ans = check(2, 3);

    if (valid(ans)) {
        output(ans);
        return 0;
    }

    cout << -1 << endl;
    return 0;

}
/**
15
1 3 2 4 6 9 3 5 10 4 6 2 9 5 6 100 43 59 43 5

15
1 2 2 3 4 4 5 6 6 7 8 8 9 10 10
*/

/**
5
1 2 2 128 4
*/
