#include <bits/stdc++.h>
using namespace std;

multiset <int> nums, nums_copy;

unordered_map <int, int> BR, BR1, BR2;

void ERASE(multiset <int>& s, int x) {
    s.erase(x);
    BR[x]--;

    for (int i = 0; i < BR[x]; i++) {
        s.insert(x);
    }
}

void ERASE1(multiset <int>& s, int x) {
    s.erase(x);
    BR1[x]--;

    for (int i = 0; i < BR1[x]; i++) {
        s.insert(x);
    }
}

void ERASE2(multiset <int>& s, int x) {
    s.erase(x);
    BR2[x]--;

    for (int i = 0; i < BR2[x]; i++) {
        s.insert(x);
    }
}


pair <multiset <int>, multiset <int>> check(int a, int r) {
    int current = a;

    multiset <int> one, two;

    while (nums.find(current) != nums.end()) {
        ERASE(nums, current);
        one.insert(current);
        current += r;
    }

    if (nums.size() < 2) return {one, nums};

    auto it = nums.begin();
    current = *it;

    r = -(*(it));
    it++;
    r += *it;

    while (nums.find(current) != nums.end()) {
        ERASE(nums, current);
        two.insert(current);
        current += r;
    }

    if (nums.size()) return {};
    return {one, two};
}


void output(pair <multiset <int>, multiset <int>>& p) {
    if (p.second.size() == 0) {
        int x = *(p.first.begin());
        ERASE1(p.first, x);
        p.second.insert(x);
    } else if (p.first.size() == 0) {
        int x = *(p.second.begin());
        ERASE2(p.second, x);
        p.first.insert(x);
    }

    cout << p.first.size() << ' ' << p.second.size() << '\n';
    for (int x : p.first) cout << x << ' ';
    cout << endl;
    for (int x : p.second) cout << x << ' ';
    cout << endl;
}

bool valid(pair <multiset <int>, multiset <int>>& p) {
    return ((bool) p.first.size()) || ((bool) p.second.size());
}

int v[100001];

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> v[i];

        nums_copy.insert(v[i]);
        BR[v[i]]++;
    }

    sort(v, v + n);

    pair <multiset <int>, multiset <int>> ans;

    nums = nums_copy;
    ans = check(v[0], v[1] - v[0]);

    if (valid(ans)) {
        for (int x : ans.first) BR1[x]++;
        for (int x : ans.second) BR2[x]++;

        output(ans);
        return 0;
    }

    if (n == 2) {
        cout << -1 << endl;
        return 0;
    }

    nums = nums_copy;
    ans = check(v[0], v[2] - v[0]);

    if (valid(ans)) {
        for (int x : ans.first) BR1[x]++;
        for (int x : ans.second) BR2[x]++;

        output(ans);
        return 0;
    }

    nums = nums_copy;
    ans = check(v[1], v[2] - v[1]);

    if (valid(ans)) {
        for (int x : ans.first) BR1[x]++;
        for (int x : ans.second) BR2[x]++;

        output(ans);
        return 0;
    }

    cout << -1 << endl;

    return 0;

}
