#include <bits/stdc++.h>
#include "saddle.h"
using namespace std;

long long v[501][501];
long long N, M;

bool is_valid_cell(long long x, long long y) {
    return 0 < x && x <= N && 0 < y && y <= M;
}

pair <long long, pair <long long, long long>> ask(long long x, long long y) {
    if (!is_valid_cell(x, y)) return {LLONG_MAX, {x, y}};
    if (v[x][y] != 0) return {v[x][y], {x, y}};
    v[x][y] = value(x, y);

    return {v[x][y], {x, y}};
}

pair <long long, pair <long long, long long>> ask_group(long long x, long long y) {
    return min({ask(x - 1, y), ask(x + 1, y), ask(x, y - 1), ask(x, y + 1), ask(x, y)});
}

pair <long long, long long> find_saddle_polong long(long long n, long long m) {
    N = n;
    M = m;

    long long x = (N + 1) / 2, y = (M + 1) / 2, br = 0;

    while (1) {
        auto val = ask_group(x, y);
        if (val == ask(x, y)) return {x, y};
        x = val.second.first;
        y = val.second.second;

        br++;
    }

    return {x, y};
}
